<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#eze
# ***** END LICENSE BLOCK *****
#
# Contributor : Aurelien ANTOINE (http://ilpleut.be/)
#
# connection class with pop extention // manipulate mail box
# without the imap extension

require (dirname(__FILE__)."/pop/pop3.php");

class ConnectionSoft {
	
	var $mbox;
	var $server;
	var $protocol;
	var $login;
	var $passwd;
	var $errors;
	
	var $ids=array();
	
	var $pop3;
	
	function ConnectionSoft($server,$protocol,$login,$passwd) {
		$this->protocol=$protocol;
		$this->login=$login;
		$this->passwd=$passwd;
		$this->pop3=new pop3_class;
		$this->pop3->hostname=$server;

		#for testing
		#$this->pop3->debug=1;
		#$this->pop3->html_debug=1;
	}
	
	function connect() {
		if(($this->errors=$this->pop3->Open())==""){
			if(($this->errors=$this->pop3->Login($this->login,$this->passwd,0))=="") {
				return TRUE;
			}
		}
		return FALSE;
	}
	
	function display_error() {
		return ($this->errors);
	}
	
	function close() {
		/*if((!$this->errors=$this->pop3->ResetDeletedMessages())=="") {
			return FALSE;
		}*/
		if((!$this->errors=$this->pop3->Close())=="") {
			return FALSE;
		}
		return TRUE;
	}
	
	function get_ids() {
		$result=$this->pop3->ListMessages("",0);
		$this->ids=array();
		if(count($result)>0) {
			foreach($result as $id => $size){
				array_push($this->ids,$id);
			}
		}
		return (count($this->ids));
	}
	
	function delete($id) {
		if(($this->errors=$this->pop3->DeleteMessage($id))=="") {
			return TRUE;
		}
		return FALSE;
	}
	
	function get($id) {
		if(($this->errors=$this->pop3->RetrieveMessage($id,$headers,$body,-1))=="") {
			$message=implode("\r\n",$headers)."\r\n\r\n".implode("\r\n",$body);
			return($message);
		}
		//echo $this->errors;
		return FALSE;
	}
}
?>
